local assets=
{
	Asset("ANIM", "anim/ornament_light.zip"),
	Asset("IMAGE", "images/inventoryimages/ornament_light.tex" ),
	Asset("ATLAS", "images/inventoryimages/ornament_light.xml"),
}
local prefabs = {
}

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
    MakeInventoryFloatable(inst, "idle_water", "idle")
	
    anim:SetBank("ornament_light")
    anim:SetBuild("ornament_light") 
    anim:PlayAnimation("idle")	
    
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM    
    -------
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/ornament_light.xml"
	
	inst:AddComponent("appeasement")
    inst.components.appeasement.appeasementvalue = TUNING.APPEASEMENT_SMALL
	
	local light = inst.entity:AddLight()
    light:SetFalloff(0.7)
    light:SetIntensity(.5)
    light:SetRadius(0.5)
    light:SetColour(180/255, 180/255, 180/255)
    light:Enable(true)
    inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )

    inst.components.inventoryitem:SetOnDroppedFn(function() inst.Light:Enable(true) end)
    inst.components.inventoryitem:SetOnPickupFn(function() inst.Light:Enable(false) end)
    
    return inst
end

return Prefab( "common/inventory/ornament_light", fn, assets, prefabs) 
