require "prefabutil"

local assets=
{
	Asset("ANIM", "anim/wintertree.zip"),
}

local INTENSITY = 0.85

local function fadein(inst)
	inst.components.fader:StopAll()
	inst.AnimState:PlayAnimation("idle", true)
	inst.Light:Enable(true)
	inst.Light:SetIntensity(0)
	inst.components.fader:Fade(0, INTENSITY, 3+math.random()*2, function(v) inst.Light:SetIntensity(v) end, function() end)
end

local function fadeout(inst)
	inst.components.fader:StopAll()
	inst.AnimState:PlayAnimation("idle", true)
	inst.components.fader:Fade(INTENSITY, 0, .75+math.random()*1, function(v) inst.Light:SetIntensity(v) end, function() inst.Light:Enable(false) end)
end

local timeto_SetColour = 0 
local timeto_Set = 24 

local function updatelight(inst)

	local randcolor1 = math.random(150,255)
	local randcolor2 = math.random(150,255)
	local randcolor3 = math.random(150,255)

	if GetClock():IsDusk() or GetClock():IsNight() then
		timeto_SetColour = timeto_SetColour + 1 
		if not inst.lighton then
				inst.Light:SetColour(randcolor1/255,randcolor2/255,randcolor3/255) 
				fadein(inst)
		else
				if timeto_SetColour > timeto_Set then
					inst.Light:SetColour(randcolor1/255,randcolor2/255,randcolor3/255) 
					timeto_SetColour = 0 
				end
				inst.Light:Enable(true)
				inst.Light:SetIntensity(INTENSITY)
		end
		inst.lighton = true
	else
		if inst.lighton then
				fadeout(inst)
		else
				inst.Light:Enable(false)
				inst.Light:SetIntensity(0)
			end
		inst.lighton = false
	end
end


local slotpos = {}  --采用冰包的格子数
for y = 0, 2 do
	table.insert(slotpos, Vector3(-162, -y*75 + 75 ,0))
	table.insert(slotpos, Vector3(-162 +75, -y*75 + 75 ,0))
end

local function itemtest(inst, item, slot)--检测可放入物品
	if  --core
	    item.prefab == "log" or
		item.prefab == "boards" or
	    item.prefab == "cutgrass" or
		item.prefab == "twigs" or
	    item.prefab == "livinglog" or 
		--rog
        item.prefab == "acorn" or
        item.prefab == "pinecone" or
		--sw
		item.prefab == "bamboo" or
		item.prefab == "vine" or
		item.prefab == "palmleaf" or
        item.prefab == "jungletreeseed" then
		return true
	end
end

local function onopen(inst)
	if not inst:HasTag("burnt") then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")	
	end
end 

local function onclose(inst) 
	if not inst:HasTag("burnt") then
		inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")		
	end
end 

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PushAnimation("wintertree")
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("wintertree")
end

local function fn(Sim)
	local inst = CreateEntity()
		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()

		local minimap = inst.entity:AddMiniMapEntity()
		minimap:SetIcon("wintertree.tex")

		local light = inst.entity:AddLight()
		inst.Light:SetFalloff(0.6)
		inst.Light:SetIntensity(0.8)
		inst.Light:SetRadius(4)
		light:Enable(false)

		inst.AnimState:SetBank("wintertree")
		inst.AnimState:SetBuild("wintertree")
		inst.AnimState:PlayAnimation("idle", true)

		MakeObstaclePhysics(inst, 0.9) 

		inst:AddComponent("sanityaura")
		inst.components.sanityaura.aura = TUNING.SANITYAURA_SMALL

		inst:AddComponent("inspectable")
		
        inst:AddComponent("container")
    	inst.components.container.onopenfn = onopen
        inst.components.container.onclosefn = onclose
		inst.components.container:SetNumSlots(#slotpos)	
	    inst.components.container.itemtestfn = itemtest
    	inst.components.container.widgetslotpos = slotpos
        inst.components.container.widgetanimbank = "ui_icepack_2x3"
        inst.components.container.widgetanimbuild = "ui_icepack_2x3"	
        inst.components.container.widgetpos = Vector3(0,200,0)
	    inst.components.container.side_align_tip = 160
		
		inst:AddComponent("lootdropper")

		inst:AddComponent("workable")
		inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
		inst.components.workable:SetWorkLeft(3)
		inst.components.workable:SetOnFinishCallback(onhammered)
		inst.components.workable:SetOnWorkCallback(onhit)

		inst:AddComponent("fader")

		inst:ListenForEvent("clocktick",
		function()
			updatelight(inst)
		end, GetWorld())

	return inst
end

return Prefab( "common/wintertree", fn, assets),
	MakePlacer("common/wintertree_placer", "wintertree", "wintertree", "idle")